﻿using System;
using System.IO;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace GoogleMapsLayerTest8677
{
    public partial class Form1 : Form
    {
        private static readonly object helper = new object();
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.Meter;
            winformsMap1.CurrentExtent = new RectangleShape(-20037508, 20037508, 20037508, -20037508);

            
            GoogleMapsLayer googleMapsLayer = new GoogleMapsLayer(null, "", "AIzaSyAAEaQLPRPJ6EdRlArVMtRXJZpcLyrXNpY") { MapType = GoogleMapsMapType.Satellite };
            //googleMapsLayer.WebProxy = new WebProxy("127.0.0.1", 1080);
            googleMapsLayer.TileMode = GoogleMapsTileMode.MultiTile;
            googleMapsLayer.SendingWebRequest += GoogleMapsLayer_SendingWebRequest;

            var layerOverlay = new LayerOverlay();
            layerOverlay.Layers.Add(googleMapsLayer);

            winformsMap1.Overlays.Add(layerOverlay);
            winformsMap1.Refresh();
        }

        private void GoogleMapsLayer_SendingWebRequest(object sender, SendingWebRequestEventArgs e)
        {
            lock (helper)
            {
                using (var file = File.Open("log.txt", FileMode.OpenOrCreate))
                {
                    var writer = new StreamWriter(file);
                    writer.WriteLine($"{DateTime.Now} | {e.WebRequest.RequestUri.AbsoluteUri}");
                    writer.Close();
                    writer.Dispose();
                }
            }
        }
    }
}
